%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It performs diagonal correction applying Von Kries' model in an 8x8 
% DCT block in YCbCr space comprising of all the components
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function dct_CI_cc_ycbcr=block_diagonal_correction_YCBCR(dct_CI_ycbcr,kr,kg,kb)

 dct_CI_cc_ycbcr=dct_CI_ycbcr;

        Y=double(dct_CI_ycbcr(1,1,1))/8; U=double(dct_CI_ycbcr(1,1,2))/8-128; V=double(dct_CI_ycbcr(1,1,3))/8-128;
        denom=(1.17*(kr+kg+kb)*Y+(2.02*kb-0.39*kg)*U+(1.6*kr-0.82*kg)*V);
        if(denom>0)
        f=(3.51*Y+1.63*U+0.78*V)/(1.17*(kr+kg+kb)*Y+(2.02*kb-0.39*kg)*U+(1.6*kr-0.82*kg)*V);
        Yu=f*((0.585*kg+.117*kb+.304*kr)*Y+(0.416*kr-0.41*kg)*V+(0.202*kb-0.195*kg)*U);
        Uu=f*((-0.339*kg+0.515*kb-0.176*kr)*Y+(0.113*kg+0.889*kb)*U+(0.238*kg-0.24*kr)*V);
        Vu=f*((-0.433*kg-0.082*kb+0.515*kr)*Y+(0.144*kg-0.141*kb)*U+(0.303*kg+0.704*kr)*V);
        elseif(denom==0)
              Yu=0; Uu=0; Vu=0;
        else
            Yu=Y; Uu=U; Vu=V;
        end
        if((Yu>255) || ((Uu+128)>255) || ((Vu+128)>255))
            sprintf('Yu=%f Uu=%f Vu=%f',Yu,Uu+128,Vu+128)
        end
        dct_CI_cc_ycbcr(1,1,1)=8*Yu; dct_CI_cc_ycbcr(1,1,2)=8*(Uu+128); dct_CI_cc_ycbcr(1,1,3)=8*(Vu+128);

return