%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It returns mean YCbCr values with their standard deviations of the
%estimated illuminant spectra by Nearest Neighbor Classification method. 
% Input Y_val,Cb_val and Cr_val are the mean in YCbCr space, The canonical illuminat set is 
% in illuminant_set and the statistics available under ../statdir.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [mY mCb mCr sY sCb sCr min_dist]=col_by_NN(Y_val,Cb_val,Cr_val,illuminant_set,statdir)

[il_r il_c]=size(illuminant_set); 

meanY=zeros(il_c);
meanCb=zeros(il_c);
meanCr=zeros(il_c);
sdY=zeros(il_c);
sdCb=zeros(il_c);
sdCr=zeros(il_c);
covYCb=zeros(il_c);
covYCr=zeros(il_c);
covCbCr=zeros(il_c);

% Read statistics

for il=1:il_c
     illuminant=char(illuminant_set(il));
  statfile=[sprintf(statdir) 'stat_' sprintf(illuminant) '.yuvmean'];
 % sprintf('Opening file %s ', statfile)
  ifp=fopen(statfile,'r');
   meanY(il)=fscanf(ifp,'%f',1);
   meanCb(il)=fscanf(ifp,'%f',1);
   meanCr(il)=fscanf(ifp,'%f',1);
      sdY(il)=fscanf(ifp,'%f',1);
      sdCb(il)=fscanf(ifp,'%f',1);
      sdCr(il)=fscanf(ifp,'%f',1);
      covYCb(il)=fscanf(ifp,'%f',1);
      covYCr(il)=fscanf(ifp,'%f',1);
      covCbCr(il)=fscanf(ifp,'%f',1);
     fclose(ifp);
end

   dist=zeros(1,il_c);
   
                  for til=1:il_c
                    diff_vect=[Cb_val-meanCb(til) Cr_val-meanCr(til)];
                    cov_matrix=[sdCb(til)^2 covCbCr(til); covCbCr(til) sdCr(til)^2];
                     dist(til)=diff_vect*inv(cov_matrix)*diff_vect';
                   end


 
 
  
     % get minimum distance illuminants
       [min_dist index]=min(dist);
%         display(score);
%         display(max_score);
  
    
      mY=meanY(index); mCb=meanCb(index); mCr=meanCr(index);
      sY=sdY(index); sCb=sdCb(index); sCr=sdCr(index);
    
    return
      