%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It performs diagonal correction applying Von Kries' model.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function CI_cc=diagonal_correction(CI,kr,kg,kb)

[h w d]=size(CI);

 CI_cc=zeros(h,w,d);
for i=1:h
    for j=1:w
        R=CI(i,j,1); G=CI(i,j,2); B=CI(i,j,3);
        L=R+G+B; ru=kr*R/L; gu=kg*G/L; bu=kb*B/L;
        lu=ru+gu+bu;
        Ru=ru*L/lu; Gu=gu*L/lu; Bu=bu*L/lu;
        CI_cc(i,j,1)=Ru; CI_cc(i,j,2)=Gu; CI_cc(i,j,3)=Bu;
    end
end
return
        