%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It performs diagonal correction applying Von Kries' model in the YCbCr space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function CI_cc_ycbcr=diagonal_correction_YCBCR(CI_ycbcr,kr,kg,kb)

[h w d]=size(CI_ycbcr);

 CI_cc_ycbcr=zeros(h,w,d);
for i=1:h
    for j=1:w
        Y=double(CI_ycbcr(i,j,1)); U=double(CI_ycbcr(i,j,2))-128; V=double(CI_ycbcr(i,j,3))-128;
          denom=(1.17*(kr+kg+kb)*Y+(2.02*kb-0.39*kg)*U+(1.6*kr-0.82*kg)*V);
          if(denom>0)
          f=(3.51*Y+1.63*U+0.78*V)/(1.17*(kr+kg+kb)*Y+(2.02*kb-0.39*kg)*U+(1.6*kr-0.82*kg)*V);
        Yu=f*((0.585*kg+.117*kb+.304*kr)*Y+(0.416*kr-0.41*kg)*V+(0.202*kb-0.195*kg)*U);
        Uu=f*((-0.339*kg+0.515*kb-0.176*kr)*Y+(0.113*kg+0.889*kb)*U+(0.238*kg-0.24*kr)*V);
        Vu=f*((-0.433*kg-0.082*kb+0.515*kr)*Y+(0.144*kg-0.141*kb)*U+(0.303*kg+0.704*kr)*V);
          else
              sprintf('factor for diagonal correction negative: Y=%f U=%f V=%f',Y,U,V)
              Yu=Y; Uu=U; Vu=V;
          end
        CI_cc_ycbcr(i,j,1)=Yu; CI_cc_ycbcr(i,j,2)=Uu+128; CI_cc_ycbcr(i,j,3)=Vu+128;
        if((Yu>255) || (Uu>255) || (Vu>255))
            sprintf('Yu=%f Uu=%f Vu=%f',Yu,Uu,Vu)
        end
    end
end
return