%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Implementation of GRW. CI should be in RGB space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [mR mG mB]=mean_illuminant_RGB(CI,R_thresh,G_thresh,B_thresh)

[h w d]=size(CI);

count=0;
sumR=0;
sumG=0;
sumB=0;

 for i=1:h
     for j=1:w
         if((CI(i,j,1)>R_thresh) && (CI(i,j,2)>G_thresh) && (CI(i,j,3)>B_thresh))
             sumR=sumR+CI(i,j,1);
             sumG=sumG+CI(i,j,2);
             sumB=sumB+CI(i,j,3);
             count=count+1;
         end
         
     end
 end
   if(count>0)
   mR=sumR/count;
   mG=sumG/count;
   mB=sumB/count;
   else
       sprintf('No pixel found for correction')
       mR=0;
       mG=0;
       mB=0;
   end
   return