%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Implementation of MXW-YCbCr. CI should be in YCbCr space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [mY mCb mCr]=mean_illuminant_YCbCr(CI,Y_thresh)

[h w d]=size(CI);

count=0;
sumY=0;
sumCb=0;
sumCr=0;

 for i=1:h
     for j=1:w
         if((CI(i,j,1)>Y_thresh))
             sumY=sumY+CI(i,j,1);
             sumCb=sumCb+CI(i,j,2);
             sumCr=sumCr+CI(i,j,3);
             count=count+1;
         end
         
     end
 end
   if(count>0)
   mY=sumY/count;
   mCb=sumCb/count;
   mCr=sumCr/count;
   else
       sprintf('No pixel found for correction')
       mY=0;
       mCb=0;
       mCr=0;
   end
   return