%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% Implementation of the alpha rooting technique.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Y =enhance_composite_alpha_rooting(C,alpha,maxDC)

[h w d]=size(C);

 Y=C;
 X=C(:,:,1);
 U=C(:,:,2);
 V=C(:,:,3);
 
 for i=1:h
     for j=1:w
         if(abs(X(i,j))>1e-3)
         X(i,j)=X(i,j)*(abs(X(i,j))/maxDC)^(alpha-1);
         end
     end
 end
 

 Y(:,:,1)=X;
 Y(:,:,2)=U;
 Y(:,:,3)=V;

  return