%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% Implementation of "Image Enhancement Using a Contrast Measure in the
% Compressed Domain", by J. Tang, E. Peli and S. Acton, IEEE SPL, vol. 10,
% no. 10, oct. , 2003, pp. 289-292.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Y =enhance_composite_contrast_method(C,lamda)


[h w d]=size(C);

 Y=C;
 X=C(:,:,1);
 U=C(:,:,2);
 V=C(:,:,3);

 H=zeros(14); % Final gain factor
 
 E0=abs(X(1,1));
 
 enh_X=X;

enh_cum_E=E0;
cum_E=E0;

for n=1:14
    H(n)=enh_cum_E/cum_E;
    for i=1:h
        for j=1:w
            if(i+j-2==n)
                enh_X(i,j)=lamda*H(n)*X(i,j);
                enh_cum_E=enh_cum_E+abs(enh_X(i,j));
                cum_E=cum_E+abs(X(i,j));
            end
        end
    end
end
    
    

 Y(:,:,1)=enh_X;
 Y(:,:,2)=U;
 Y(:,:,3)=V;

  return