%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% Implementation of the CES algorithm.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Y =enhance_composite_dc_blk(C,beta,maxDC,k,sigma_thresh)



[h w d]=size(C);

 Y=C;
 X=C(:,:,1);
 U=C(:,:,2);
 V=C(:,:,3);

% compute s.d by  summing of normailised AC coefficinets.

 xdc=X(1,1)/8;
 
variance=0;
for i=1:8
    for j=1:8
        variance=variance+(X(i,j)*X(i,j))/64;
    end
end

variance=variance-xdc*xdc;
sigma=sqrt(variance);

if(sigma >sigma_thresh)
   A1=block_composition_matrix(2,4);
   Cd=zeros(h,w,d);
   Cc=zeros(h,w,d);
 inv_A1=inv(A1);
 Cd(:,:,1)=inv_A1*X*inv_A1';
 Cd(:,:,2)=inv_A1*U*inv_A1';
 Cd(:,:,3)=inv_A1*V*inv_A1';
 
   for i=0:1
       for j=0:1
           Cd(i*4+1:i*4+4,j*4+1:j*4+4,:)=enhance_composite_dc_sigma_4(Cd(i*4+1:i*4+4,j*4+1:j*4+4,:),beta,maxDC,k);
       end
   end
    Cc(:,:,1)=A1*Cd(:,:,1)*A1';
    Cc(:,:,2)=A1*Cd(:,:,2)*A1';
    Cc(:,:,3)=A1*Cd(:,:,3)*A1';
 
     Y=Cc;
return
end



 nxdc=xdc/maxDC;
 enxdc=nxdc*(2-beta*nxdc);
 
 exdc=enxdc*maxDC;
 factor=exdc/xdc;
 
 if(factor>255/(xdc+k*sigma))
    
     factor=255/(xdc+k*sigma);
 end
 
 if(factor<1)
     factor=1;
 end
 

 
 
 udc=U(1,1)/8-128;
 vdc=V(1,1)/8-128;
 eudc=factor*udc+128;
 evdc=factor*vdc+128;
 U=factor*U;
 V=factor*V;
   U(1,1)=eudc*8;
   V(1,1)=evdc*8;


 Y(:,:,1)=factor*X;

 Y(:,:,2)=U;
 Y(:,:,3)=V;

  return
















