%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% Implementation of the CES in block of size 4x4.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Y =enhance_composite_dc_sigma_4(C,beta,maxDC,k)
% Modified Algorithm  based on s.d. the enhancement factor is readjusted.
% DC value within the limit of 255 * k. sigma



[h w d]=size(C);

 Y=C;
 X=C(:,:,1);
 U=C(:,:,2);
 V=C(:,:,3);
 

% compute s.d by  summing of normailised AC coefficinets.

 xdc=X(1,1)/4;
 
variance=0;
for i=1:4
    for j=1:4
        variance=variance+(X(i,j)*X(i,j))/16;
    end
end

variance=variance-xdc*xdc;
sigma=sqrt(variance);


 nxdc=xdc/maxDC;
 enxdc=nxdc*(2-beta*nxdc);
 
 exdc=enxdc*maxDC;
 factor=exdc/xdc;
 
 if(factor>255/(xdc+k*sigma))
   
     factor=255/(xdc+k*sigma);
 end
 
 if(factor<1)
     factor=1;
 end
 

 
 
 udc=U(1,1)/4-128;
 vdc=V(1,1)/4-128;
 eudc=factor*udc+128;
 evdc=factor*vdc+128;
 U=factor*U;
 V=factor*V;
   U(1,1)=eudc*4;
   V(1,1)=evdc*4;

 Y(:,:,1)=factor*X;

 Y(:,:,2)=U;
 Y(:,:,3)=V;

  return