%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% It demonstrates color enhancement through saturation and desaturation
%in the compressed domain.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
sprintf('Color enhancement through preservation of hue Saturation in CbCr in Compressed Domain');
clear
close all
 tic
 
imagedir='../test_images/';
%image='couple';
image='alps01';

xw=1/3; yw=1/3;
xr=0.674;yr=0.326;
xg=0.216;yg=0.716;
xb=0.162;yb=0.090;

[ur vr]=xy2nCbCr(xr,yr);
[ug vg]=xy2nCbCr(xg,yg);
[ub vb]=xy2nCbCr(xb,yb);

theta1=1;
theta2=359;
ang1=pi*theta1/180;
ang2=pi*theta2/180;
s_thresh=0.1;

factor=1; %factor of saturation
shift=10;
Threshold=3;
minSat=20;

lum_thresh=0;
wl_factor=0.2; % White luminance factor


mode=2; %0: Fixed Shift 1: Max sat through xy  2:Max sat in nCbCr 3: desaturation 4: Saturation-Desaturation
fig_count=0;

 org_I	              = imread( [ sprintf(imagedir) sprintf(image) '.bmp'],'bmp');
 
 
 [height width depth]=size(org_I);
figure(fig_count+1); imshow(uint8(org_I(1:floor(height/8)*8,1:floor(width/8)*8,:))); title('Original Image');
fig_count=fig_count+1;

                 
  [dct_s_CI_ycbcr s_maxDC]=get_DCT_JPEG(org_I);
  
  s_CI_dc_ycbcr=dct_s_CI_ycbcr(1:8:height,1:8:width,:)/8;  

  
 maxDC=double(max(max(s_CI_dc_ycbcr(:,:,1))));

switch(mode)
    case 0
        sprintf('Saturation by a fixed shift')
         ftitle='Saturation by shift';
         CI_ycbcr_sat=sat_CbCr(s_CI_dc_ycbcr,factor,shift,Threshold);
         
    case 1
         sprintf('Maximum Saturation in Nomralized CbCr through xy')
         ftitle='Saturation in Nomralized CbCr through xy';
        CI_ycbcr_sat=max_sat_CbCr(s_CI_dc_ycbcr, ang1,ang2,s_thresh,xr,yr,xg,yg,xb,yb,xw,yw);
    case 2
         sprintf('Maximum Saturation in Nomralized CbCr through nCbCr')
         ftitle='Saturation in Nomralized CbCr';
        CI_ycbcr_sat=max_sat_CbCr_nCbCr(s_CI_dc_ycbcr, ang1,ang2,s_thresh,ur,vr,ug,vg,ub,vb);
   case 3
         sprintf('Desaturation')
         ftitle='Desaturation';
        CI_ycbcr_sat=desat_YCbCr(s_CI_dc_ycbcr, ang1,ang2,s_thresh,lum_thresh,wl_factor);    
    case 4
         sprintf('Saturation (nCbCr)-Desaturation')
         ftitle='Saturation (nCbCr)-Desaturation';
        CI_ycbcr_sat1=max_sat_CbCr_nCbCr(s_CI_dc_ycbcr, ang1,ang2,s_thresh,ur,vr,ug,vg,ub,vb);
        CI_ycbcr_sat=desat_YCbCr(CI_ycbcr_sat1, ang1,ang2,s_thresh,lum_thresh,wl_factor);    
    
    otherwise
         sprintf('Saturation by a fixed shift')
    CI_ycbcr_sat=sat_CbCr(s_CI_dc_ycbcr,factor,shift,Threshold);
end    


   
               dct_CI_cc_ycbcr=dct_s_CI_ycbcr;
               dct_CI_cc_ycbcr(1:8:height,1:8:width,:)=8.0*double(CI_ycbcr_sat);
              
               
               out=get_Image_from_DCT_JPEG(dct_CI_cc_ycbcr);
           
              figure(fig_count+1); imshow(out(1:floor(height/8)*8,1:floor(width/8)*8,:)); fig_count=fig_count+1;
                      title(ftitle);  
            
 
 sprintf('cef=%f',colourfulness_metric(uint8(out(1:floor(height/8)*8,1:floor(width/8)*8,:)))/colourfulness_metric(uint8(org_I(1:floor(height/8)*8,1:floor(width/8)*8,:))))
 
   toc