%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Function description:
% It computes maximum saturation point in nCbCr space given theta as hue angle.
%(xr,yr)-Red (xg,yg)-- Green (xb,yb)-- Blue (0,0)--ref. white

%nCbCr: red=204.289655 degree green=331.089524 degree blue=70.565681 degree
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function [nx,ny]=max_sat_nCbCr(theta, xr,yr,xg,yg,xb,yb)


        thr=find_angle(xr,yr,0,0);
        thg=find_angle(xg,yg,0,0);
        thb=find_angle(xb,yb,0,0);

	if(abs(theta-thr)<=0) 
        nx=xr;
        ny=yr;
         sprintf('Pure red!')
        return;
    end
	if(abs(theta-thg)<=0) 
        nx=xg;
        ny=yg;
         sprintf('Pure green!')
        return;
    end
	if(abs(theta-thb)<=0)
       nx=xb;
       ny=yb;
       sprintf('Pure blue!')
       return;
    end

        x1=0.2*cos(theta-pi/2);
        y1=0.2*sin(theta-pi/2);
	if((theta<=thg) && (theta>thr)) 
		[nx,ny]= find_xy(0,0,x1,y1,xr,yr,xg,yg); 
    elseif((theta<=thb) || (theta>thg)) %in nCbCr domain angles are different
		 [nx,ny]=  find_xy(0,0,x1,y1,xg,yg,xb,yb); 
    else
	      [nx,ny]=  find_xy(0,0,x1,y1,xb,yb,xr,yr);
    end
    return