%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Function description:
% It computes maximum saturation point in NXYZ space given theta as hue angle.
%(xr,yr)-Red (xg,yg)-- Green (xb,yb)-- Blue (xw,yw)--ref. white
% Typical parameter values are given below.
% 	xr=0.674;yr=0.326;
% 	xg=0.216;yg=0.716;
% 	xb=0.162;yb=0.090;

%  thr=91.0*M_PI/180.0;thg=193.0*M_PI/180.0;thb=326.0*M_PI/180.0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function [nx,ny]=max_sat_xy(theta, xr,yr,xg,yg,xb,yb,xw, yw)

        thr=find_angle(xr,yr,xw,yw);
        thg=find_angle(xg,yg,xw,yw);
        thb=find_angle(xb,yb,xw,yw);

	if(theta==thr) 
        px=xr;
        py=yr;
        return;
    end
	if(theta==thg) 
        px=xg;
        py=yg;
        return;
    end
	if(theta==thb)
       px=xb;
       py=yb;
       return;
    end

        x1=xw+0.2*cos(theta-pi/2);
        y1=yw+0.2*sin(theta-pi/2);
	if((theta<=thg) && (theta>thr)) 
		[nx,ny]= find_xy(xw,yw,x1,y1,xr,yr,xg,yg); 
    elseif((theta<=thb) && (theta>thg)) 
		 [nx,ny]=  find_xy(xw,yw,x1,y1,xg,yg,xb,yb); 
    else
	      [nx,ny]=  find_xy(xw,yw,x1,y1,xb,yb,xr,yr);
    end
    return

