%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% It demonstrates image sharpening operation.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sprintf('Image Sharpening : Image Filtering with Overlap and Add method')
clear all
tic
mode=0; %0: General 1: Approximation by threshoding a coeff. 2: Sparse Neighbor Computation 3: All Sparse
 Threshold=1e-19; %Threshold for truncating CMP submatrices
 sigma=2.0;
 Blk_size=8;
 lamda=0.9;
 
 
 
imagedir='../test_images/';
 image = 'boats';
%image = 'watch';

%I 		= imread( [sprintf(imagedir) sprintf(image) '.orig.jpg'],'jpg');
I 		= imread( [sprintf(imagedir) sprintf(image) '.bmp'],'bmp');
%I 		= imread( [sprintf(imagedir) sprintf(image) '.tif'],'tif');
sprintf('Image loaded')

 
   figure(1); imshow(I); title(sprintf(image));
   
   
   h=truncate_gaussian_1D(3*Blk_size,2*Blk_size,sigma);
    
[nrow flt_length]=size(h);
 if((3*Blk_size+1-flt_length) < 0)
     sprintf('Filter length not appropriate')
     return
 end
    g=[h zeros(1,3*Blk_size+1-flt_length)];
    C_3N=dct_type1_basis(3*Blk_size);
    
     H=C_3N*g';
   
    dct_I=blkproc(I,[Blk_size,Blk_size],@dct2);
      switch(mode)
        case(0)
            sprintf('Performing filtering with exact computation')
        flt_dct_I=blkproc(dct_I,[8 8],[8,8],@filter_overlap_and_add_sym_cosine,H);
        case(1)
            sprintf('Performing filtering with approx. filter coefficients')
         flt_dct_I=blkproc(dct_I,[8 8],[8,8],@approx_filter_overlap_and_add_sym_cosine,H,Threshold);
        case(2)
            sprintf('Performing filtering with sparse neighboring blocks')
            flt_dct_I=blkproc(dct_I,[8 8],[8,8],@sparse_neighbor_filter_overlap_and_add_sym_cosine,H,Threshold);
        case(3)
            sprintf('Performing filtering with all sparse  blocks')
             flt_dct_I=blkproc(dct_I,[8 8],[8,8],@sparse_filter_overlap_and_add_sym_cosine,H,Threshold);
        otherwise
         flt_dct_I=blkproc(dct_I,[8 8],[8,8],@filter_overlap_and_add_sym_cosine,H);
     end
    I_flt=blkproc(flt_dct_I,[Blk_size,Blk_size],@idct2);
     figure(2); imshow(uint8(I_flt)); title('Filtered image in Compression');


 sharp_dct_I=dct_I+lamda*(dct_I-flt_dct_I);
 I_sharp=blkproc(sharp_dct_I,[Blk_size,Blk_size],@idct2);
     figure(3); imshow(uint8(I_sharp)); title('Sharpened Image');
   
  
toc