%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% Implementation of the HRA.
% LxM -> PxQ blocks of size N=height/L=width/M
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=Arbitrary_resize(X,L,M,P,Q)



[height width]=size(X);

if(height/L~=width/M)
    sprintf('Block sizes should of type NxN');
    return
end

N=height/L; %Assume of same size in both direction
 
 

  A1=block_composition_matrix(L,N);
 
  A2=block_composition_matrix(M,N);
 
 
 tY1=A1*X*A2';
 
 if((P<L) && (Q<M))
      tY2=sqrt((P*Q)/(L*M))*tY1(1:P*N,1:Q*N);
 elseif((P>L) && (Q>M))
       tY2=sqrt((P*Q)/(L*M))*[tY1 zeros(L*N,Q*N-M*N) ;
                              zeros(P*N-L*N, M*N) zeros(P*N-L*N,Q*N-M*N)];
 elseif((P>L) && (Q<M))
             tY2=sqrt((P*Q)/(L*M))*[tY1(:,1:Q*N) ;
                              zeros(P*N-L*N, Q*N)];
 elseif((P<L) && (Q>M))
             tY2=sqrt((P*Q)/(L*M))*[tY1(1:P*N,:) zeros(P*N,(Q-M)*N)] ;
 else
                Y=X;
                return
  end
         
                            
 B1=block_composition_matrix(P,N);
 
 B2=block_composition_matrix(Q,N);


 Y=B1'*tY2*B2;
 
 
  return