%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% It upsamples a block by a factor of 2 using approximation   followed 
 % by decomposition. 
% X: 8 x 8 block.
% Y: 16 x 16 block.
% mode: Sub-band (1) / Truncated (0) approximation.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=IDAD(X,mode)


[height width]=size(X);

 tX=2*X;

 if(mode==1)
       %sprintf('Computing Subband Approximation during Upsampling ')
       sb=get_subband_factor_matrix(2*height,2*width);
      tX=sb.*tX;
     
   end
   
z=zeros(height,width);

tY=[tX z;z z];
 
 A=block_composition_matrix(2,height);
 inv_A=inv(A);
 Y=inv_A*tY*inv_A';
 
 
  return
