%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% It upsamples a block by a factor of 2 using decomposition  followed by
% approximation.
% X: 8 x 8 block.
% Y: 16 x 16 block.
% mode: Sub-band (1) / Truncated (0) approximation.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=IDDA(X,mode)


[height width]=size(X);

 
 A=block_composition_matrix(2,height/2);
 inv_A=inv(A);
 dX=inv_A*X*inv_A';
  B11=2*dX(1:height/2,1:width/2);
 B12=2*dX(1:height/2,width/2+1:width);
 B21=2*dX(height/2+1:height,1:width/2);
 B22=2*dX(height/2+1:height,width/2+1:width);

   if(mode==1)
       %sprintf('Computing Subband Approximation during Upsampling ')
       sb=get_subband_factor_matrix(height,width);
      B11=sb.*B11;
      B12=sb.*B12;
      B21=sb.*B21;
      B22=sb.*B22;
  
   end
  z=zeros(height/2,width/2);
 uB11=[B11 z; z z];
 uB12=[B12 z; z z];
 uB21=[B21 z; z z];
 uB22=[B22 z; z z];
 
 Y=[uB11 uB12;uB21 uB22];
 
 
  return
