%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% It downsamples a block by a factor of 2 using approximation followed by composition.
%  X : 16x16 elements i.e. 4 8x8 DCT blocks. 
% mode=0 : truncation.
%     =1 : subband approximation.
% Y : 8 x 8 block.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=IHAC(X,mode)

[height width]=size(X);

 B11=X(1:height/2,1:width/2);
 B12=X(1:height/2,width/2+1:width);
 B21=X(height/2+1:height,1:width/2);
 B22=X(height/2+1:height,width/2+1:width);
 
 
 sB11=0.5*B11(1:height/4,1:width/4);
 sB12=0.5*B12(1:height/4,1:width/4);
 sB21=0.5*B21(1:height/4,1:width/4);
 sB22=0.5*B22(1:height/4,1:width/4);
 if(mode==1)
     %sprintf('Computing Subband Approximation during downsampling ')
    sb=get_subband_factor_matrix(height/2,width/2);
    sB11=sB11./sb;
    sB12=sB12./sb;
    sB21=sB21./sb;
    sB22=sB22./sb;
end
    
 A=block_composition_matrix(2,height/4);
 
 compB=[sB11 sB12;sB21 sB22];
 
  Y=A*compB*A';
  return
 
 
 
