%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% It downsamples a block by a factor of 2 using composition followed by approximation.
%  X : 16x16 elements i.e. 4 8x8 DCT blocks. 
% mode=0 : truncation.
%     =1 : subband approximation.
% Y : 8 x 8 block.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=IHCA(X,mode)

[height width]=size(X);

 A=block_composition_matrix(2,height/2);
 B=A*X*A';

 Y=0.5*B(1:height/2,1:width/2);
 
 if(mode==1)
     %sprintf('Computing Subband Approximation during downsampling ')
    sb=get_subband_factor_matrix(height,width);
    Y=Y./sb;
    
end
    
 return
 