%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% The program demonstrates image resizing with integral factors.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sprintf('Image Resizing be L x M')


clear
tic

 imagedir='../test_images/';
image = 'watch.orig';

L=3;
 M=2;
 
 


 I 		= imread( [sprintf(imagedir) sprintf(image) '.jpg'],'jpg');

sprintf('Image loaded')



 
 [height width]=size(I);
 
   figure(1); imshow(I); title(sprintf(image));
   
    dct_I=blkproc(I,[8,8],@dct2);
    dsmpl_dct_I=blkproc(dct_I,[L*8 M*8],@LM_downsize,L,M);
    
    
    
    I_dnapx=blkproc(dsmpl_dct_I,[8,8],@idct2);
    
figure(2); imshow(uint8(I_dnapx)); title('Downsampled image');
   

    upsmpl_dct_I=blkproc(dct_I,[8 8],@LM_upsize,L,M);
    
    
    
    I_upapx=blkproc(upsmpl_dct_I,[8,8],@idct2);
figure(3); imshow(uint8(I_upapx)); title('Upsampled image');

 

 DJ=blkproc(I,[L M],@LM_mean);
 UJ=interpolate(I,M,L,'cubic');
 [hDJ wDJ]=size(DJ);
 [hUJ wUJ]=size(UJ);
 

  upsmpl_dct_I=blkproc(dsmpl_dct_I,[8 8],@LM_upsize,L,M);
  
   
     
  I_apx=blkproc(upsmpl_dct_I,[8,8],@idct2);
figure(4); imshow(uint8(I_apx)); title('Down & Up sampled image');

 
 
 sprintf('Downsample Image PSNR= %g', psnr(I_dnapx(1:hDJ,1:wDJ),DJ))
 sprintf('Upsample Image PSNR= %g', psnr(I_upapx(1:hUJ,1:wUJ),UJ))
 sprintf('Down & Upsampled Image PSNR= %g', psnr(I_apx(1:height-8,1:width-8),I(1:height-8,1:width-8)))
 
  
toc
