%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% Implementation of the LMUS algorithm.
% X: 8 x 8 elements.
% Y : 8L x 8M elements.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=LM_upsize(X,L,M)

[height width]=size(X);

zTR=zeros(8,8*(M-1));
zB=zeros(8*(L-1),8*M);

tY=[sqrt(L*M)*X zTR;zB];
 
 A1=block_composition_matrix(L,height);
 inv_A1=inv(A1);
 A2=block_composition_matrix(M,width);
 inv_A2=inv(A2);
 Y=inv_A1*tY*inv_A2';
 
 
  return
