%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% It upsamples a block by a factor of 2 using the CMP.
%  X : 8x8 DCT block.
%  Y : 16x16 DCT block.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=Park_upsize(X)

[height width]=size(X);
Y=zeros(16,16);
 if((height~=8) || (width ~=8))
     sprintf('Only valid for 8x8 blocks')
     return
 end

   W=[16 10.2023 0 -3.4449 0 2.1214 0 -1.5763 0 1.2936 0 -1.1339 0 1.0450 0 -1.0048];

 W_d0=[W(1)   2*W(2)        0       2*W(4)       0          2*W(6)    0          2*W(8) ;
      0     W(2)+W(4)     W(1)     W(2)+W(6)     0        W(4)+W(8)   0       W(6)+W(10);
      0     W(4)+W(6)       0      W(2)+W(8)     W(1)     W(2)+W(10)  0       W(4)+W(12) ;
      0     W(6)+W(8)       0      W(4)+W(10)    0        W(2)+W(12) W(1)     W(2)+W(14);
      0     W(8)+W(10)      0      W(6)+W(12)    0        W(4)+W(14)  0       W(2)+W(16);
      0     W(10)+W(12)     0      W(8)+W(14)    0        W(6)+W(16)  0       W(4)-W(16);
      0     W(12)+W(14)     0      W(10)+W(16)   0        W(8)-W(16)   0       W(6)-W(14);
      0     W(14)+W(16)     0      W(12)-W(16)   0       W(10)-W(14)  0       W(8)-W(12)];
  
  S=[1  0   0   0  0 0  0 0 ;
     0  -1  0   0  0 0  0 0 ;
     0   0  1   0  0 0  0 0 ;
     0   0  0  -1  0 0  0 0 ;
     0   0  0   0  1 0  0 0 ;
     0   0  0   0  0 -1 0 0 ;
     0   0  0   0  0 0  1  0 ;
     0   0  0   0  0 0  0 -1 ];
 W_d1=S*W_d0*S;

 
   F=[4*sqrt(2)  0   0   0  0 0  0 0 ;
     0  4  0   0  0 0  0 0 ;
     0   0 4   0  0 0  0 0 ;
     0   0  0  4  0 0  0 0 ;
     0   0  0   0  4 0  0 0 ;
     0   0  0   0  0 4 0 0 ;
     0   0  0   0  0 0  4  0 ;
     0   0  0   0  0 0  0 4 ];
 G=inv(F);
 Q=G*W_d0*F;
 P=S*Q*S;
 
 Y(1:8,1:8)=Q*X*Q';
 Y(1:8,9:16)=Q*X*P';
 Y(9:16,1:8)=P*X*Q';
 Y(9:16,9:16)=P*X*P';

 Y=Y/256;
 
 
 


   
  return