%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% The program demonstrates conversion of an HDTV frame to an NTSC one.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sprintf('HDTV--NTSC Arbitrary Rational Resizing main: 27/6/2010')

clear
tic

imagedir='../test_images/';
image = 'P1000033_hdtv';


 
 
 N=8;
 

 P=4;
 Q=1;
 L=9;
 M=3;
 

 
 fx=P/L;
 fy=Q/M;
 
 

 


 CI 		= imread( [sprintf(imagedir) sprintf(image) '.tif'],'tif');

sprintf('Image loaded')

 I=CI(:,:,2);
 [height width]=size(I);
 
   figure(1); imshow(I); title(sprintf(image));

    dct_I=blkproc(I,[N,N],@dct2);
    resize_dct_I=blkproc(dct_I,[L*N,M*N],@Arbitrary_resize,L,M,P,Q);
    
    I_resize=blkproc(resize_dct_I,[N,N],@idct2);
    
     [h_r w_r]=size(I_resize);
     
   h_d=floor(height*fx);
   w_d=floor(width*fy);
   if(h_r<h_d)
       h_d=h_r;
   end
   if(w_r<w_d)
       w_d=w_r;
   end

figure(2); imshow(uint8(I_resize(1:h_d,1:w_d))); title('Resized image');

  

 I_resize1=uint8(I_resize(1:h_d,1:w_d));
 
toc