%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% The program demonstrates image halving and doubling using different
% techniques.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sprintf('Image Halving and Doubling')


clear
tic

imagedir='../test_images/';



image = 'watch.orig';

TR=0;
 SB=1;
 mode=TR;


 I 		= imread( [sprintf(imagedir) sprintf(image) '.jpg'],'jpg');

sprintf('Image loaded')

 
   figure(1); imshow(I); title(sprintf(image));
  
   DJ=halfImage(I);
   UJ=interpolate(DJ,2,2,'cubic');
 
    figure(2); imshow(uint8(DJ)); title('Spatial  Downsampling');
 
    
    dct_I=blkproc(I,[8,8],@dct2);
    
    dsmpl_dct_LDU=blkproc(dct_I,[16 16],@LDU_downsize);
    I_LDU_ds=blkproc(dsmpl_dct_LDU,[8,8],@idct2);
    figure(3); imshow(uint8(I_LDU_ds)); title('LDU Down Sampling');
    
    dsmpl_dct_IHCA=blkproc(dct_I,[16 16],@IHCA,mode);
    I_ihca=blkproc(dsmpl_dct_IHCA,[8,8],@idct2);
    figure(4); imshow(uint8(I_ihca)); title('IHCA Downsampling');
   
     
    
    dsmpl_dct_IHAC=blkproc(dct_I,[16 16],@IHAC,mode);
    I_ihac=blkproc(dsmpl_dct_IHAC,[8,8],@idct2);
    figure(5); imshow(uint8(I_ihac)); title('IHAC Downsampling');
    
    
    
    dsmpl_dct_Park=blkproc(dct_I,[16 16],@Park_downsize);
    I_Park_ds=blkproc(dsmpl_dct_Park,[8,8],@idct2);
    figure(6); imshow(uint8(I_Park_ds)); title('Park Downsampling');
    
    
    
    dct_DJ=blkproc(DJ,[8,8],@dct2);
    
   
    upsmpl_dct_DJ=blkproc(dct_I,[8 8],@IDAD,mode);
    I_IDAD=blkproc(upsmpl_dct_DJ,[8,8],@idct2);
    figure(7); imshow(uint8(I_IDAD)); title('IDAD Upsampling');
  

  
    upsmpl_dct_DJ=blkproc(dct_I,[8 8],@IDDA,mode);
    I_IDDA=blkproc(upsmpl_dct_DJ,[8,8],@idct2);
    figure(8); imshow(uint8(I_IDDA)); title('IDDA Upsampling');
    
    
    upsmpl_dct_DJ=blkproc(dsmpl_dct_Park,[8 8],@Park_upsize);
    I_Park_us=blkproc(upsmpl_dct_DJ,[8,8],@idct2);
    figure(9); imshow(uint8(I_Park_us)); title('Park Upsampling');

 
  upsmpl_dct_IHCA=blkproc(dsmpl_dct_IHCA,[8 8],@IDDA,mode);
  I_IHCA_IDDA=blkproc(upsmpl_dct_IHCA,[8,8],@idct2);
  figure(10); imshow(uint8(I_IHCA_IDDA)); title('IHCA-IDDA');

  upsmpl_dct_IHAC=blkproc(dsmpl_dct_IHAC,[8 8],@IDAD,mode);
  I_IHAC_IDAD=blkproc(upsmpl_dct_IHAC,[8,8],@idct2);
  figure(11); imshow(uint8(I_IHAC_IDAD)); title('IHAC-IDAD');
  

 upsmpl_dct_IHCA=blkproc(dsmpl_dct_IHCA,[8 8],@IDAD,mode);
  I_IHCA_IDAD=blkproc(upsmpl_dct_IHCA,[8,8],@idct2);
  figure(12); imshow(uint8(I_IHCA_IDAD)); title('IHCA-IDAD');
  
 upsmpl_dct_IHAC=blkproc(dsmpl_dct_IHAC,[8 8],@IDDA,mode);
  I_IHAC_IDDA=blkproc(upsmpl_dct_IHAC,[8,8],@idct2);
  figure(13); imshow(uint8(I_IHAC_IDDA)); title('IHAC-IDDA');
  
   upsmpl_dct_Park=blkproc(dsmpl_dct_Park,[8 8],@Park_upsize);
  I_Park_ds_us=blkproc(upsmpl_dct_Park,[8,8],@idct2);
  figure(14); imshow(uint8(I_Park_ds_us)); title('Park\_DS\_US');

  
  sprintf('PSNR for downsampled images ')
 sprintf(' LDU=%g IHCA=%g IHAC=%g Park_downsize=%g', psnr(I_LDU_ds,DJ), psnr(I_ihca,DJ), psnr(I_ihac,DJ), psnr(I_Park_ds,DJ))

 

 
 sprintf('PSNR for Downsampled and Upsampled images ')
 sprintf('IHAC-IDDA= %g  IHAC-IDAD=%g IHCA-IDDA=%g IHCA-IDAD=%g Park-DS-US= %g', psnr(I_IHAC_IDDA,I), psnr(I_IHAC_IDAD,I),psnr(I_IHCA_IDDA,I), psnr(I_IHCA_IDAD,I), psnr(I_Park_ds_us,I))
 
 
 
toc
