%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% Implementation of interpolation in the spatial domain.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function J=interpolate(I,M,L,method)

  xScale=double(M);
  yScale=double(L);
  sprintf(method)
 [r c]=size(I);
 [X Y]=meshgrid(1:1/xScale:c+1/xScale,1:1/yScale:r+1/yScale);
 
  dJ=interp2(double(I),X,Y,method);
  
  J=uint8(dJ);
  
  return