%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% It demonstrates transcoding from DCT to DWT.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sprintf('DCT to Wavelt Transcoding: version 1 18/9/10')
 
close all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear
tic

Blk_size=8;
fig_count=0;

De=dct_dn2_bs_even(Blk_size);
Do=dct_dn2_bs_odd(Blk_size);

imagedir='../test_images/';
image = 'watch.orig';


%I 		= imread( [sprintf(image) '.orig.jpg'],'jpg');
 I 		= imread( [sprintf(imagedir) sprintf(image) '.jpg'],'jpg');
%I 		= imread( [sprintf(image) '.tif'],'tif');
sprintf('Image loaded')
dI=double(I);
 
 [height width]=size(I);
   
   fig_count=fig_count+1; figure(fig_count); 
   imshow(I); title(sprintf(image));
   
   
   dct_I=blkproc(dI,[Blk_size,Blk_size],@dct2);
   
ha=[6/8 2/8 -1/8] % 5/3 analysis
ga=[1 -1/2] % 5/3 analysis hpf

hs=[1 1/2] %5/3 synthesis lpf
gs=[6/8 -2/8 -1/8] % 5/3 synthesis hpf

%     ha=[0.603 0.267 -0.078 -0.017 0.027] %9/7 lpf analysis
%     ga=[1.115 -0.591 -0.058 0.091] %9/7 hpf analysis
%     
%    hs=[1.115 0.591 -0.058 -0.091] %9/7 lpf synthesis
%    gs=[0.603 -0.267 -0.078 0.017 0.027] %9/7 hpf synthesis
    


       


   [nrow hlength]=size(ha);
   [nrow glength]=size(ga);
    
    
      
        
        
   
   
    
    

    % Transcoding into Wavelet subbands 
    
    % Filtering in DCT
    
    [nrow flt_length]=size(ha);
     if((3*Blk_size+1-flt_length) < 0)
         sprintf('Filter length not appropriate')
         return
     end
    he=[ha zeros(1,3*Blk_size+1-flt_length)];
    C_3N=dct_type1_basis(3*Blk_size);
    
     Hl=C_3N*he';
     
     [nrow flt_length]=size(ga);
     if((3*Blk_size+1-flt_length) < 0)
         sprintf('Filter length not appropriate')
         return
     end
    ge=[ga zeros(1,3*Blk_size+1-flt_length)];
   
    
     Hr=C_3N*ge';
     
     N=Blk_size;
     A_3_N=block_composition_matrix(3,N);
 
  D=convert_diagonal_matrix(Hl(1:3*N));
   B=A_3_N'*D*A_3_N;
  Gl=sqrt(6*N)*B(1:N,N+1:2*N);
  Fl=sqrt(6*N)*B(N+1:2*N,N+1:2*N);
  El=sqrt(6*N)*B(2*N+1:3*N,N+1:2*N);
  
   
   
  D=convert_diagonal_matrix(Hr(1:3*N));
  B=A_3_N'*D*A_3_N;
  Gr=sqrt(6*N)*B(1:N,N+1:2*N);
  Fr=sqrt(6*N)*B(N+1:2*N,N+1:2*N);
  Er=sqrt(6*N)*B(2*N+1:3*N,N+1:2*N);
  
   
     
      flt_dct_CA=blkproc(dct_I,[Blk_size Blk_size],[Blk_size,Blk_size],@filter_overlap_and_add_separable_arbitrary,El,Fl,Gl,El,Fl,Gl,Blk_size);
      flt_dct_CH=blkproc(dct_I,[Blk_size Blk_size],[Blk_size,Blk_size],@filter_overlap_and_add_separable_arbitrary,El,Fl,Gl,Er,Fr,Gr,Blk_size);
      flt_dct_CV=blkproc(dct_I,[Blk_size Blk_size],[Blk_size,Blk_size],@filter_overlap_and_add_separable_arbitrary,Er,Fr,Gr,El,Fl,Gl,Blk_size);
      flt_dct_CD=blkproc(dct_I,[Blk_size Blk_size],[Blk_size,Blk_size],@filter_overlap_and_add_separable_arbitrary,Er,Fr,Gr,Er,Fr,Gr,Blk_size);
     
    
     
   
        CA=blkproc(flt_dct_CA,[Blk_size,Blk_size],@upsample_DCT,De,De);
        CH=blkproc(flt_dct_CH,[Blk_size,Blk_size],@upsample_DCT,De,Do);
        CV=blkproc(flt_dct_CV,[Blk_size,Blk_size],@upsample_DCT,Do,De);
        CD=blkproc(flt_dct_CD,[Blk_size,Blk_size],@upsample_DCT,Do,Do);
    
    fig_count=fig_count+1; figure(fig_count); 
   imshow(uint8(CA)); title('CA');
   
   fig_count=fig_count+1; figure(fig_count);  
   
   imshow(uint8(CH));title('CH');
   
   fig_count=fig_count+1; figure(fig_count); 
   
   imshow(uint8(CV));title('CV');
   
   fig_count=fig_count+1; figure(fig_count); 
  
   imshow(uint8(CD)); title('CD');
        
        
        [nrow hlength]=size(hs);
        [nrow glength]=size(gs);
        f_hs=[hs(hlength:-1:2)  hs(1:hlength)];
        f_gs=[gs(glength:-1:2)  gs(1:glength)];

        
    I_synth=idwtImage(CA,CH,CV,CD,f_hs,f_gs);
    fig_count=fig_count+1; figure(fig_count); 
    imshow(uint8(I_synth)); title('IDWT of  Image');
   
    sprintf('PSNR=%f DB',psnr(I(8:height-8,8:width-8),I_synth(8:height-8,8:width-8)))
toc