%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It provides a block composition matrix for converting M adjacent N point
% DCT blocks into an MN point DCT block. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a = block_composition_matrix(M,N)
  a=zeros(M*N,M*N);
  
  B_MN=dct_type2_basis(M*N);
  B_N=dct_type2_basis(N);
  B_mod=zeros(M*N,M*N);
  
  for u=0:M-1
      B_mod(u*N+1:u*N+N,u*N+1:u*N+N)=B_N;
  end
   a=B_MN*inv(B_mod);
return