%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Filter bank implementation of DWT.
% I: Input image.
% ha: FIR of low pass analysis filter.
% ga: FIR of high pass analysis filter.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [CA,CH,CV,CD]=dwtImage(I,ha,ga)

 [height width]=size(I);
 
 dI=double(I);
 
 hha=ha'*ha;
 hga=ha'*ga;
 gha=ga'*ha;
 gga=ga'*ga;
    
   CA_f=conv2(dI,hha,'same');
   CH_f=conv2(dI,hga,'same');
   CV_f=conv2(dI,gha,'same');
   CD_f=conv2(dI,gga,'same');
   
   CA=CA_f(1:2:height,1:2:width);
   CH=CH_f(1:2:height,2:2:width);
   CV=CV_f(2:2:height,1:2:width);
   CD=CD_f(2:2:height,2:2:width);
   
   return