%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Filter bank implementation of IDWT.
% CA,CH,CV,CD: Wavelet sub-bands (down-sampled).
% hs: FIR of low pass synthesis filter.
% gs: FIR of high pass synthesis filter.
% I: Output image in double.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function I=idwtImage(CA,CH,CV,CD,hs,gs)


 [h w]=size(CA);
 
 height=2*h;
 width=2*w;
 
 
 
 hhs=hs'*hs;
 hgs=hs'*gs;
 ghs=gs'*hs;
 ggs=gs'*gs;
    
    CA_up_sp=zeros(height,width);
    CA_up_sp(1:2:height,1:2:width)=CA;
    CH_up_sp=zeros(height,width);
    CH_up_sp(1:2:height,2:2:width)=CH;
    CV_up_sp=zeros(height,width);
    CV_up_sp(2:2:height,1:2:width)=CV;
    CD_up_sp=zeros(height,width);
    CD_up_sp(2:2:height,2:2:width)=CD;
 
   JA=conv2(CA_up_sp,hhs,'same');
   JH=conv2(CH_up_sp,hgs,'same');
   JV=conv2(CV_up_sp,ghs,'same');
   JD=conv2(CD_up_sp,ggs,'same');
   
    I=JA+JH+JV+JD;
   
   return