%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts pixels in  LHS (Intensity-hue-saturation according to 
% CIE Chromaticity chart) to normlaized CIE-XYZ (NXYZ) color space. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function out=LHS_to_NXYZ(I,xw,yw)
%I: input image in LHS space
% (xw,yw): white reference, usually (0.32,0.33)

[height width depth]=size(I);
lum = double(I(:,:,1));
angle = double(I(:,:,2));
sat = double(I(:,:,3));

nx=zeros(height,width);
ny=zeros(height,width);
nz=zeros(height,width);
        
	for i=1:height
	    for j=1:width
                nx(i,j)=xw+sat(i,j)*cos(angle(i,j)-pi/2);
                ny(i,j)=yw+sat(i,j)*sin(angle(i,j)-pi/2);
                nz(i,j)=lum(i,j);
        end
    end

                
out(:,:,1) = nx;
out(:,:,2) = ny;
out(:,:,3) = nz;
	return