%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts an RGB pixel into YCbCr.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [Y Cb Cr]=RGB2YCbCr(R,G,B)

Tr1 = [0.5022    0.0975    0.2558; -0.2899    0.4375   -0.1476; -0.3664   -0.0711    0.4375];

Y 	= Tr1(1,1)*G +	Tr1(1,2)*B + Tr1(1,3)*R; 
Cb	= Tr1(2,1)*G +	Tr1(2,2)*B + Tr1(2,3)*R + 128;
Cr	= Tr1(3,1)*G +	Tr1(3,2)*B + Tr1(3,3)*R + 128;

return