%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts image from RGB color space  to YCbCr.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

function out=RGB_YCbCr(I)


Tr1 = [0.5022    0.0975    0.2558; -0.2899    0.4375   -0.1476; -0.3664   -0.0711    0.4375];


R = double(I(:,:,1));
G = double(I(:,:,2));
B = double(I(:,:,3));

Y 	= Tr1(1,1)*G +	Tr1(1,2)*B + Tr1(1,3)*R; 
Cb	= Tr1(2,1)*G +	Tr1(2,2)*B + Tr1(2,3)*R + 128;
Cr	= Tr1(3,1)*G +	Tr1(3,2)*B + Tr1(3,3)*R + 128;


 out(:,:,1) = Y;
out(:,:,2) = Cb;
out(:,:,3) = Cr;

  out=uint8(out);
 
  return