%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts pixels in  CIE-XYZ color space to NXYZ color space. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function out=XYZ_NXYZ(I)
%Assume input in XYZ space

X= double(I(:,:,1));
Y = double(I(:,:,2));
Z= double(I(:,:,3));
[height width]=size(X);

nX=zeros(height,width);
nY=zeros(height,width);
K=zeros(height,width);

for i=1:height
	    for j=1:width
                K(i,j)=X(i,j)+Y(i,j)+Z(i,j);
                if(K(i,j)>0.0001)
                 nX(i,j)=X(i,j)/K(i,j);
                 nY(i,j)=Y(i,j)/K(i,j);
                else
                    nX(i,j)=1/3.0;
                    nY(i,j)=1/3.0;
                end
        end
    end


out(:,:,1) = nX;
out(:,:,2) =  nY;
out(:,:,3) =  K;

 
  return