%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts an YCbCr pixel into RGB.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [R G B]=YCbCr2RGB(Y, Cb, Cr)

Tr1 = [0.5022    0.0975    0.2558; -0.2899    0.4375   -0.1476; -0.3664   -0.0711    0.4375];
Tr3=inv(Tr1);

G = Tr3(1,1)*Y + Tr3(1,2)*(Cb-128) + Tr3(1,3)*(Cr-128);
B = Tr3(2,1)*Y + Tr3(2,2)*(Cb-128) + Tr3(2,3)*(Cr-128);
R = Tr3(3,1)*Y + Tr3(3,2)*(Cb-128) + Tr3(3,3)*(Cr-128);  

return