%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It returns Cb and Cr values from a pixel in YUV color space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function [Cb Cr]=getCbCr(Y,u,v)
%Given Y, u and v find Cb and Cr.
% u=Cb/(aY+bCb+cCr)
% v=Cr/(aY+bCb+cCr)
%a=3.51, b=1.99 and c=0.14
%[Cb Cr]'=aY inv([1-bu -cu; -bv 1-cv]) [u v]'


a=3.51; b=1.99; c=0.14;
F=inv([1-b*u -c*u; -b*v 1-c*v]);
z=a*Y*F*[u v]';
Cb=z(1);
Cr=z(2);
return