%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Returns 1-D gaussian function values in the +ve half with N elements.
% For any coordinate value beyond m, functional value is 0. The mean is at
% 0 and sigma is the standard deviation.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function g=truncate_gaussian_1D(N,m,sigma) 

 g=zeros(1,N);
 
 for x=1:m+1
         g(x)=exp(-((x-1)*(x-1))/(2*sigma*sigma))/(sqrt(2*pi)*sigma);
 end
 return