%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It computes PSNR values between two images.
% ref---> Reference  image.
% rec---> Reconstructed  image. 
% val---> PSNR value in DB.
% It works for  color  images.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function val=cpsnr(ref,rec)

  R=double(ref(:,:,1));
  G=double(ref(:,:,2));
  B=double(ref(:,:,3));
  
  R1=double(rec(:,:,1));
  G1=double(rec(:,:,2));
  B1=double(rec(:,:,3));
  
  [r c]=size(R);
  
 
  err=sum(sum(((R-R1).*(R-R1))+((G-G1).*(G-G1))+((B-B1).*(B-B1))))/(3*r*c);
  if(err>0)
  sqrterr=sqrt(err);
  
  val=20*log10(255.0/sqrterr);
  else
      sprintf('Both images are same. Returning a value 999999. Error=%f ',err)
      val=999999;
  end
  return